//+------------------------------------------------------------------+
//|                                     Shinigami Closer EA v1.1.mq4 |
//|                                                     by Shinigami |
//|                                              Shini1984@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Shinigami, 2009"
#property link      "Shini1984@gmail.com"

extern string WorkInfo = "Set Work parameter to 1 for the EA to work";
extern int Work=0;
extern string SymbolInfo = "Only close orders with current symbol? 0 = close ALL orders"; // symbol = currency pair
extern int UseSymbol = 1;
extern string MagicInfo = "Closing orders with a magic number? (-1 = close ALL, 0 = manual trades)";
extern int MagicNumber = -1; // if you only want to close EA trades, put the EA's magic number here
extern string CloseInfo1 = "Simple settings part";
extern string CloseTypes1 = "Close trade orders? (buys and sells, 1=yes)";
extern int BuysSells = 0;
extern string CloseTypes2 = "Delete pending orders? (buystops, selllimits ect, 1=yes)";
extern int StopsLimits = 0;
extern string CloseInfo2 = "Specific settings part";
extern string Types0 = "Close Buys (1 = yes)";
extern int Buys=0;
extern string Types1 = "Close Sells (1 = yes)";
extern int Sells=0;
extern string Types2 = "Delete BuyStops (1 = yes)";
extern int BuyStops=0;
extern string Types3 = "Delete SellStops (1 = yes)";
extern int SellStops=0;
extern string Types4 = "Delete BuyLimits (1 = yes)";
extern int BuyLimits=0;
extern string Types5 = "Delete SellLimits (1 = yes)";
extern int SellLimits=0;

//==================================================================================================+
int init()
{
Comment("Shinigami Closer EA attached to the chart!");
start();
return(0);
}
//==================================================================================================+
int start()
{
RefreshRates();
if(!IsTradeAllowed()) return(0);
if(Work!=1) return(0);
int i=0,type=-1,repeat=3;

while(repeat>0) {
for(i=0;i<=OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(UseSymbol==1&&OrderSymbol()!=Symbol()) continue;
if(MagicNumber>-1&&OrderMagicNumber()!=MagicNumber) continue;
type=OrderType();
if(type==OP_BUY) { if(BuysSells==1||Buys==1) {
     OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),Digits),999);
     Sleep(100); repeat++; break; } }
if(type==OP_SELL) { if(BuysSells==1||Sells==1) {
     OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),Digits),999);
     Sleep(100); repeat++; break; } }
if(type==OP_BUYSTOP) { if(StopsLimits==1||BuyStops==1) {
     OrderDelete(OrderTicket()); Sleep(100); repeat++; break; } }
if(type==OP_BUYLIMIT) { if(StopsLimits==1||BuyLimits==1) {
     OrderDelete(OrderTicket()); Sleep(100); repeat++; break; } }
if(type==OP_SELLSTOP) { if(StopsLimits==1||SellStops==1) {
     OrderDelete(OrderTicket()); Sleep(100); repeat++; break; } }
if(type==OP_SELLLIMIT) { if(StopsLimits==1||SellLimits==1) {
     OrderDelete(OrderTicket()); Sleep(100); repeat++; break; } }
type=-1; repeat--;
} }

return(0);
}
//==================================================================================================+
int deinit()
{
Comment(" ");
return(0);
}
//==================================================================================================+


